
#include "dma.h"

u8 DMA1_Init(void)
{
    DMA_InitTypeDef DMA_InitStructure={0};

    RCC_AHBPeriphClockCmd( RCC_AHBPeriph_DMA1, ENABLE );

    //SPI1_TX
    DMA_DeInit(DMA1_Channel3);
    DMA_InitStructure.DMA_PeripheralBaseAddr = (u32)&SPI1->DATAR;            //ַ
//    DMA_InitStructure.DMA_MemoryBaseAddr = memadr;                         //ڴַ
    DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralDST;                       //ΪݴĿĵ
    DMA_InitStructure.DMA_BufferSize = 512;                                  //DMAС
    DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;         //ַָ䡣
    DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;                  //ָ洢ַ
    DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte;  //ݵλ
    DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte;          //ô洢ݵλ
    DMA_InitStructure.DMA_Mode = DMA_Mode_Normal;                            //öӦDMAģʽΪģʽ
    DMA_InitStructure.DMA_Priority = DMA_Priority_VeryHigh;                  //DMAͨȼ
    DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;                             //ֹʹDMA洢洢Ĵ䷽ʽ
    DMA_Init( DMA1_Channel3, &DMA_InitStructure );                           //ʼDMA

    //SPI1_RX
    DMA_DeInit(DMA1_Channel2);
    DMA_InitStructure.DMA_PeripheralBaseAddr = (u32)&SPI1->DATAR;
//    DMA_InitStructure.DMA_MemoryBaseAddr = memadr;
    DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralSRC;
    DMA_InitStructure.DMA_BufferSize = 512;
    DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
    DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;
    DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte;
    DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte;
    DMA_InitStructure.DMA_Mode = DMA_Mode_Normal;
    DMA_InitStructure.DMA_Priority = DMA_Priority_High;
    DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;
    DMA_Init( DMA1_Channel2, &DMA_InitStructure );

    DMA_ClearFlag(DMA1_FLAG_TC2);
    DMA_ClearFlag(DMA1_FLAG_TC3);

    SPI_I2S_DMACmd(SPI1,SPI_I2S_DMAReq_Tx,ENABLE); //ʹSPIDMA
    SPI_I2S_DMACmd(SPI1,SPI_I2S_DMAReq_Rx,ENABLE); //ʹSPIDMA

    return 0;
}

//SDд
//buffer:ݻlen:дֽ
u8 SPI_DMA_Tx(u8 *buffer , u32 len)
{
    DMA1_Channel3->CNTR=len;                    //DMAݳ
    DMA1_Channel3->MADDR=(uint32_t)buffer;      //RAMַ

    DMA_Cmd(DMA1_Channel3,ENABLE);              //DMA䣬RAM->SPI
    while( DMA_GetFlagStatus(DMA1_FLAG_TC3) == RESET);//ȴ
    DMA_Cmd(DMA1_Channel3,DISABLE);             //رDMA
    DMA_ClearFlag(DMA1_FLAG_TC3);               //־
    return 0;
}

//SD
//buffer:ݻlen:ֽ
u8 SPI_DMA_Rx(u8 *buffer , u32 len)
{
    u8 temp =0xff;

    DMA_Cmd(DMA1_Channel2,DISABLE);
    DMA_Cmd(DMA1_Channel3,DISABLE);

    DMA1_Channel2->CNTR=len;                    //DMAݳ
    DMA1_Channel2->MADDR=(uint32_t)buffer;      //RAMַ

    /*SPIΪݽʱҪʱӣ˴˴DMAͨ3SPI_Tx*/
    DMA1_Channel3->CNTR=len;
    DMA1_Channel3->MADDR=(uint32_t)&temp;        //temp=0xff
    DMA1_Channel3->CFGR&=~DMA_MemoryInc_Enable;  //ڴַ

    DMA_Cmd(DMA1_Channel2,ENABLE);               //DMAͨ2
    DMA_Cmd(DMA1_Channel3,ENABLE);               //DMAͨ3
    while(!DMA_GetFlagStatus(DMA1_FLAG_TC2));    //ȴDMAͨ2ݽ
    while(!DMA_GetFlagStatus(DMA1_FLAG_TC3));    //ȴDMAͨ3ݽ

    DMA_Cmd(DMA1_Channel2,DISABLE);
    DMA_Cmd(DMA1_Channel3,DISABLE);              //ʹDMAֹͨͣ

    DMA_ClearFlag(DMA1_FLAG_TC2);
    DMA_ClearFlag(DMA1_FLAG_TC3);                //ͨɱ־

    DMA1_Channel3->CFGR|=DMA_MemoryInc_Enable;   //ڴַ
    return 0;
}
